<template>
  <div class="order-shipments">
    <transition
      name="fadeIn"
      @after-enter="onTransitionEndList"
    >
      <template v-if="isShowedList">
        <div class="shipments-list">
          <div class="shipments-list__header">
            <span>Номера шипментов</span>
          </div>
          <div
            v-for="{ shipmentUuid, number } in shipments"
            :key="shipmentUuid"
            class="shipments-list__item"
          >
            <span>{{ number }}</span>
            <i
              v-if="isEditable"
              class="icon close"
              @click="deleteShipment(shipmentUuid)"
            />
          </div>
          <transition
            name="fadeIn"
            @after-enter="onTransitionEndList"
          >
            <div
              v-if="isCreatingActive"
              class="shipments-list__item --new"
            >
              <ObInput
                ref="input"
                v-model="number"
                @blur="onInputBlur"
                @on-enter="createShipment"
              />
            </div>
          </transition>
        </div>
      </template>
    </transition>
    <button
      v-if="isEditable"
      class="add-button"
      @click="onCreateHandler"
    >
      <i class="icon plus-sm" />
      <span>Добавить шипмент</span>
    </button>
  </div>
</template>

<script>
import ObInput from 'common-components/src/obComponents/obInput'
import api from '@/api'

export default {
  name: 'OrderShipments',
  components: {
    ObInput
  },
  props: {
    order: {
      type: Object,
      default: () => {}
    }
  },
  data () {
    return {
      isCreatingActive: false,
      number: '',
      shipments: []
    }
  },
  computed: {
    isShowedList () {
      return this.shipments && this.shipments.length || this.isCreatingActive
    },
    isSubOrder () {
      return this.order.isSuborder
    },
    isEditable () {
      const allowedStatuses = this.isSubOrder ? [ 'BOOKED', 'ALLOCATED', 'CONTRACTED', 'IN_PROCESS', 'PROCESSED' ] : [ 'NEW', 'IN_PROCESS', 'PROCESSED' ]
      return allowedStatuses.includes(this.order.status) && this.order.isEditable
    }
  },
  watch: {
    'order.uuid': {
      immediate: true,
      handler () {
        if (this.isSubOrder ? !['NEW', 'ON_DOER_SEARCH'].includes(this.order.status) : true) {
          this.getShipments()
        }
      }
    }
  },
  methods: {
    onCreateHandler () {
      this.isCreatingActive = true
    },
    onTransitionEndList () {
      if (this.isCreatingActive) {
        this.$refs && this.$refs.input.focus()
      }
    },
    onInputBlur () {
      this.isCreatingActive = false
    },
    async createShipment () {
      try {
        const method = this.isSubOrder ? api.orderProcess.createSuborderShipment : api.orderProcess.createShipment
        const { uuid, suborderSpecies } = this.order
        await method({ uuid, suborderSpecies, number: this.number })
        this.$notification({
          type: 'system_notification_success',
          message: 'Добавлен'
        })
        this.number = ''
        this.isCreatingActive = false
        this.getShipments()
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка добавления'
        })
      }
    },
    async deleteShipment (shipmentUuid) {
      try {
        const method = this.isSubOrder ? api.orderProcess.deleteSuborderShipment : api.orderProcess.deleteShipment
        const { uuid, suborderSpecies } = this.order
        await method({ uuid, suborderSpecies, shipmentUuid })
        this.$notification({
          type: 'system_notification_success',
          message: 'Удален'
        })
        this.getShipments()
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка удаления'
        })
      }
    },
    async getShipments () {
      try {
        const method = this.isSubOrder ? api.orderProcess.getSuborderShipmentsList : api.orderProcess.getShipmentsList
        const { uuid, suborderSpecies } = this.order
        this.shipments = await method({ uuid, suborderSpecies })
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки шипментов'
        })
      }
    },
  }
}
</script>

<style lang="scss" scoped>
  @import "../../../../../node_modules/common-components/src/static/css/mixins";

  .order-shipments {
    .add-button {
      display: flex;
      align-items: center;
      border: none;
      background-color: transparent;
      outline: none;
      cursor: pointer;
      .icon {
        font-size: 16px;
        color: $color-blue-navy-blue;
        margin-right: 6px;
      }
      &:hover {
        .icon {
          opacity: 0.8;
        }
      }
    }
    .shipments-list {
      margin-bottom: 25px;
      border: 1px solid $color-grey-border;
      border-radius: 3px;
      &__header {
        padding: 14px 20px;
        @include font-mixin(10px, 12px, 400, $shale-gray, 0.4px, uppercase);
      }
      &__item {
        display: flex;
        justify-content: space-between;
        align-items: center;
        padding: 10px 13px 10px 20px;
        border-top: 1px solid $lavender;
        .icon.close {
          color: $color-blue-navy-blue;
          font-size: 16px;
          opacity: 0;
          cursor: pointer;
          &:hover {
            opacity: 0.8;
          }
        }
        span {
          flex-grow: 2;
          @include font-mixin(14px, 18px, 400);
        }
        &:hover {
          background-color: $light-lavender;
          .icon.close {
            opacity: 1;
          }
        }
        &.--new {
          padding: 4px 10px 4px 10px;
          background-color: #fff!important;
          .icon.close {
            display: none!important;
          }
        }
        &::v-deep {
          .ob-input-wrap {
            height: 30px;
            width: 200px;
          }
        }
      }
    }

    .fadeIn-enter, .fadeIn-leave-to {
      opacity: 0;
    }

    .fadeIn-enter-active, .fadeIn-leave-active {
      transition: opacity 0.2s linear;
    }
  }
</style>
